> ## Documentation Index
> Fetch the complete documentation index at: https://apidocs.specurate.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Change



## OpenAPI

````yaml /openapi.json post /v1/workspaces/{workspaceId}/members/batch
openapi: 3.1.0
info:
  title: Specurate API
  description: ''
  version: 1.0.0
  contact: {}
servers:
  - url: https://app.specurate.com/api
    description: API Server
security: []
tags: []
paths:
  /v1/workspaces/{workspaceId}/members/batch:
    post:
      tags:
        - Member Batch
      summary: Change
      operationId: MemberBatchController_change_v1
      parameters:
        - name: workspaceId
          required: true
          in: path
          schema:
            type: string
            pattern: ^[1-9]\d{0,18}$
        - name: dryRun
          required: false
          in: query
          schema:
            type: string
            enum:
              - 'true'
              - 'false'
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/MemberBatchDto'
      responses:
        '200':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/MemberBatchResponseDto'
components:
  schemas:
    MemberBatchDto:
      type: object
      properties:
        userIds:
          minItems: 1
          maxItems: 100
          type: array
          items:
            type: string
            pattern: ^[1-9]\d{0,18}$
        changes:
          $ref: '#/components/schemas/MemberBatchChangesDto'
      required:
        - userIds
        - changes
      additionalProperties: false
    MemberBatchResponseDto:
      type: object
      properties:
        dryRun:
          type: boolean
        results:
          type: array
          items:
            $ref: '#/components/schemas/MemberBatchResultDto'
        counts:
          $ref: '#/components/schemas/MemberBatchCountsDto'
        seatDelta:
          type: array
          items:
            $ref: '#/components/schemas/MemberBatchSeatDeltaDto'
        approvalRequests:
          type: array
          items:
            $ref: '#/components/schemas/MemberBatchApprovalRequestDto'
        capBreaches:
          type: array
          items:
            $ref: '#/components/schemas/MemberBatchCapBreachDto'
        publicationFailed:
          type: boolean
      required:
        - dryRun
        - results
        - counts
        - seatDelta
        - approvalRequests
        - capBreaches
        - publicationFailed
    MemberBatchChangesDto:
      type: object
      properties:
        seats:
          type: object
          properties:
            add:
              minItems: 1
              maxItems: 10
              type: array
              items:
                type: string
                pattern: ^[1-9]\d{0,18}$
            remove:
              minItems: 1
              maxItems: 10
              type: array
              items:
                type: string
                pattern: ^[1-9]\d{0,18}$
          additionalProperties: false
        teams:
          type: object
          properties:
            add:
              minItems: 1
              maxItems: 20
              type: array
              items:
                type: string
                pattern: ^[1-9]\d{0,18}$
            remove:
              minItems: 1
              maxItems: 20
              type: array
              items:
                type: string
                pattern: ^[1-9]\d{0,18}$
          additionalProperties: false
        tags:
          type: object
          properties:
            add:
              maxItems: 10
              type: array
              items:
                type: string
                minLength: 1
                maxLength: 60
            remove:
              maxItems: 10
              type: array
              items:
                type: string
                minLength: 1
                maxLength: 60
          additionalProperties: false
        workspaceAccess:
          type: object
          properties:
            contactBook:
              anyOf:
                - type: string
                  enum:
                    - none
                    - view
                    - edit
                - type: 'null'
            createProjects:
              type:
                - boolean
                - 'null'
          additionalProperties: false
        projects:
          type: object
          properties:
            add:
              type: object
              properties:
                projectIds:
                  minItems: 1
                  maxItems: 100
                  type: array
                  items:
                    type: string
                    pattern: ^[1-9]\d{0,18}$
                accessLevel:
                  type: string
                  enum:
                    - edit
                    - view
              required:
                - projectIds
                - accessLevel
              additionalProperties: false
            remove:
              type: object
              properties:
                projectIds:
                  minItems: 1
                  maxItems: 100
                  type: array
                  items:
                    type: string
                    pattern: ^[1-9]\d{0,18}$
                byMember:
                  minItems: 1
                  maxItems: 100
                  type: array
                  items:
                    type: object
                    properties:
                      userId:
                        type: string
                        pattern: ^[1-9]\d{0,18}$
                      projectIds:
                        minItems: 1
                        maxItems: 100
                        type: array
                        items:
                          type: string
                          pattern: ^[1-9]\d{0,18}$
                    required:
                      - userId
                      - projectIds
                    additionalProperties: false
              additionalProperties: false
          additionalProperties: false
      additionalProperties: false
    MemberBatchResultDto:
      type: object
      properties:
        userId:
          type: string
        status:
          type: string
          enum:
            - applied
            - skipped
            - failed
        code:
          type: string
        changes:
          type: array
          items:
            $ref: '#/components/schemas/MemberBatchChangeResultDto'
      required:
        - userId
        - status
        - changes
    MemberBatchCountsDto:
      type: object
      properties:
        applied:
          type: number
        skipped:
          type: number
        failed:
          type: number
      required:
        - applied
        - skipped
        - failed
    MemberBatchSeatDeltaDto:
      type: object
      properties:
        licenseId:
          type: string
        packageKey:
          type: string
        packageName:
          type: string
        seatsAdded:
          type: number
        seatsRemoved:
          type: number
        seatsInUse:
          type: number
        seatsInUseAfter:
          type: number
        purchasedSeats:
          type:
            - number
            - 'null'
        seatPriceUsd:
          type:
            - string
            - 'null'
        interval:
          type:
            - string
            - 'null'
          enum:
            - month
            - year
            - null
      required:
        - licenseId
        - packageKey
        - packageName
        - seatsAdded
        - seatsRemoved
        - seatsInUse
        - seatsInUseAfter
        - purchasedSeats
        - seatPriceUsd
        - interval
    MemberBatchApprovalRequestDto:
      type: object
      properties:
        licenseId:
          type: string
        userId:
          type: string
      required:
        - licenseId
        - userId
    MemberBatchCapBreachDto:
      type: object
      properties:
        licenseId:
          type: string
        code:
          type: string
          enum:
            - LICENSE_SEAT_CAP_REACHED
      required:
        - licenseId
        - code
    MemberBatchChangeResultDto:
      type: object
      properties:
        kind:
          type: string
          enum:
            - seat_add
            - seat_remove
            - team_add
            - team_remove
            - tag_add
            - tag_remove
            - workspace_access
            - project_add
            - project_remove
        targetId:
          type: string
        status:
          type: string
          enum:
            - applied
            - skipped
            - failed
        code:
          type: string
        details:
          type: object
          additionalProperties: true
      required:
        - kind
        - status

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.